import React from "react";
import { ComponentStyles, ManagedClasses } from "@microsoft/fast-jss-manager";
import { ManagedJSSProps } from "./jss-manager";
/**
 * Main entry into the style manager. This function accepts a JSS style object and returns a
 * higher order component. That higher-order component can then be used to compose a component
 * with styles managed
 * @param S - The stylesheet class-name contract
 * @param C - The stylesheet design-system configuration object
 */
declare function manageJss<S, C>(styles?: ComponentStyles<S, C>): <T>(Component: React.ComponentType<T & ManagedClasses<S>>) => React.ComponentClass<ManagedJSSProps<T, S, C>>;
export { manageJss };
